/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.equivalencia;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.ClaseservicioEquivalencia;
import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.ClaseservicioEquivalenciaService;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarClaseservicioEquivalenciaController")
@Scope("prototype")
public class EditarClaseservicioEquivalenciaController extends MyGenericForwardComposer {

    @Autowired
    private ClaseservicioEquivalenciaService claseServicioEquivalenciaService;
    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    @Autowired
    private ClaseServicioService claseServicioService;
    private ClaseservicioEquivalencia claseServicioEquivalencia;
    private MyListbox claseServicioEquivalenciaList;
    private static Logger log = Logger.getLogger(EditarClaseservicioEquivalenciaController.class);
    private List<ComisionistaExterno> lsComisionistaExterno;
    private List<ClaseServicio> lsClaseServicio;
    private Combobox cmbClaseServicio;
    private Combobox cmbComissionestaExterno;
    private Textbox txtEquivalencia;
    private Button btnApagar;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public ClaseservicioEquivalencia getClaseServicioEquivalencia() {
        return claseServicioEquivalencia;
    }

    public void setClaseServicioEquivalencia(ClaseservicioEquivalencia claseServicioEquivalencia) {
        this.claseServicioEquivalencia = claseServicioEquivalencia;
    }

    public MyListbox getClaseServicioEquivalenciaList() {
        return claseServicioEquivalenciaList;
    }

    public void setClaseServicioEquivalenciaList(MyListbox claseServicioEquivalenciaList) {
        this.claseServicioEquivalenciaList = claseServicioEquivalenciaList;
    }

    public ClaseServicioService getClaseServicioService() {
        return claseServicioService;
    }

    public void setClaseServicioService(ClaseServicioService claseServicioService) {
        this.claseServicioService = claseServicioService;
    }

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    public Combobox getCmbComissionestaExterno() {
        return cmbComissionestaExterno;
    }

    public void setCmbComissionestaExterno(Combobox cmbComissionestaExterno) {
        this.cmbComissionestaExterno = cmbComissionestaExterno;
    }

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public List<ComisionistaExterno> getLsComisionistaExterno() {
        return lsComisionistaExterno;
    }

    public void setLsComisionistaExterno(List<ComisionistaExterno> lsComisionistaExterno) {
        this.lsComisionistaExterno = lsComisionistaExterno;
    }

    public Textbox getTxtEquivalencia() {
        return txtEquivalencia;
    }

    public void setTxtEquivalencia(Textbox txtEquivalencia) {
        this.txtEquivalencia = txtEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsComisionistaExterno = comisionistaExternoService.obtenerTodos();
        lsClaseServicio = claseServicioService.buscarTodosExceto(-1);

        super.doAfterCompose(comp);

        claseServicioEquivalencia = (ClaseservicioEquivalencia) Executions.getCurrent().getArg().get("claseservicioEquivalencia");
        claseServicioEquivalenciaList = (MyListbox) Executions.getCurrent().getArg().get("claseServicioEquivalenciaList");

        if (claseServicioEquivalencia.getClaseservicioequivalenciaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            cmbClaseServicio.setDisabled(true);
            cmbComissionestaExterno.setDisabled(true);
        }

        cmbClaseServicio.setFocus(true);
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        cmbComissionestaExterno.getSelectedItem();
        cmbClaseServicio.getSelectedItem();
        txtEquivalencia.getText();

        try {

            ComisionistaExterno comisionistaExterno = claseServicioEquivalencia.getComisionistaExterno();
            Comboitem cbiClaseServicio = cmbClaseServicio.getSelectedItem();
            ClaseServicio claseServicio = null;
            if (cbiClaseServicio != null) {
                claseServicio = (ClaseServicio) cbiClaseServicio.getValue();
                claseServicioEquivalencia.setClaseservicio(claseServicio);
            }

            List<ClaseservicioEquivalencia> lsClaseServicioEquivalente =
                    claseServicioEquivalenciaService.buscar(claseServicio, comisionistaExterno);


            boolean podeSalvar = false;
            if (lsClaseServicioEquivalente.isEmpty()) {
                podeSalvar = true;
            } else {
                if (claseServicioEquivalencia.getClaseservicioequivalenciaId() != null) {
                    for (ClaseservicioEquivalencia p : lsClaseServicioEquivalente) {
                        if (p.getClaseservicioequivalenciaId().equals(claseServicioEquivalencia.getClaseservicioequivalenciaId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }


            List<ClaseservicioEquivalencia> lsEquivalente =
                    claseServicioEquivalenciaService.buscarEquivalencia(claseServicioEquivalencia);

            boolean podeSalvarEquivalencia = false;
            if (lsEquivalente.isEmpty()) {
                podeSalvarEquivalencia = true;
            } else {
                if (claseServicioEquivalencia.getClaseservicioequivalenciaId() != null) {
                    for (ClaseservicioEquivalencia p : lsEquivalente) {
                        if (p.getClaseservicioequivalenciaId().equals(claseServicioEquivalencia.getClaseservicioequivalenciaId())) {
                            podeSalvarEquivalencia = true;
                        }
                    }
                }
            }

            if (!podeSalvarEquivalencia) {
                Messagebox.show(
                        Labels.getLabel("MSG.Equivalencia.Existe"),
                        Labels.getLabel("editarClaseservicioEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }
            if (podeSalvar) {

                if (claseServicioEquivalencia.getClaseservicioequivalenciaId() == null) {
                    claseServicioEquivalenciaService.suscribir(claseServicioEquivalencia);
                    claseServicioEquivalenciaList.addItem(claseServicioEquivalencia);
                } else {
                    claseServicioEquivalenciaService.actualizacion(claseServicioEquivalencia);
                    claseServicioEquivalenciaList.updateItem(claseServicioEquivalencia);
                }
                Messagebox.show(
                        Labels.getLabel("editarClaseservicioEquivalenciaController.MSG.suscribirOK"),
                        Labels.getLabel("editarClaseservicioEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarClaseservicioEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarClaseservicioEquivalenciaController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarClaseservicioEquivalenciaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarClaseservicioEquivalenciaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                claseServicioEquivalenciaService.borrar(claseServicioEquivalencia);

                Messagebox.show(
                        Labels.getLabel("editarClaseservicioEquivalenciaController.MSG.borrarOK"),
                        Labels.getLabel("editarClaseservicioEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                claseServicioEquivalenciaList.removeItem(claseServicioEquivalencia);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
